/*
Crea un espai de taules anomenat TFG lligat a un fitxer de dades anomenat tfg.dat
amb una grandria inicial de 10 MB, si existeix el fitxer, el reutilitza
i s'ampliar automticament cada 10MB fins a un mxim de 500MB
*/
CREATE TABLESPACE TFG
    DATAFILE 'tfg.dat'
    SIZE 10M
    REUSE
    AUTOEXTEND ON NEXT 10M MAXSIZE 500M;
      
/*
Crea un usuari TFGAdmin
amb contrasenya passTFG
que treballar a l'espai de taules permanent TFG
i el seu espai de taules temporal ser TEMP
*/
CREATE USER TFGAdmin
    IDENTIFIED BY passTFG
    DEFAULT TABLESPACE TFG
    TEMPORARY TABLESPACE TEMP;

/*Permet que es connecti a la base de dades*/
GRANT CREATE SESSION TO TFGAdmin IDENTIFIED BY passTFG;
/*Permet que crei taules al seu esquema*/
GRANT CREATE TABLE TO TFGAdmin IDENTIFIED BY passTFG;
/*Permet que crei procediments al seu esquema*/
GRANT CREATE PROCEDURE TO TFGAdmin IDENTIFIED BY passTFG;
/*Permet que crei esdeveniments al seu esquema*/
GRANT CREATE TRIGGER TO TFGAdmin IDENTIFIED BY passTFG;
/*Permet que crei vistes al seu esquema*/
GRANT CREATE VIEW TO TFGAdmin IDENTIFIED BY passTFG;
/*Permet que crei vistes materialitzades al seu esquema*/
GRANT CREATE MATERIALIZED VIEW TO TFGAdmin IDENTIFIED by passTFG;
/*Permet que crei sequncies de nombres enters generats automticament*/
GRANT CREATE SEQUENCE TO TFGAdmin IDENTIFIED by passTFG;
/*Permet que crei rutines que gestionen ndexos*/
GRANT CREATE INDEXTYPE TO TFGAdmin IDENTIFIED by passTFG;
/*Treu les seves limitacions d'espai en el seu espai de taules*/
GRANT UNLIMITED TABLESPACE TO TFGAdmin IDENTIFIED by passTFG;
/*Permet crear operadors que fan referncies a indextypes, consultes SQL o sentncies DML*/
GRANT CREATE OPERATOR TO TFGAdmin IDENTIFIED by passTFG;