--Aquest parmetre permet veure els resultats que van dirigits a la sortida de consola
set serveroutput on size 30000;
--Canvia el format de les dates de la sessi a dies de 24h
alter session set nls_date_format = 'dd/mm/yyyy hh24:mi:ss';

/*
Aquesta prova permet verificar el correcte funcionament del procediment crucial tornaIdTaula
*/
--Mostra els registres de Log i Component ordenats inversament per veure l'ltima clau
select * from LOG ORDER BY idLog DESC;
select * from component order by idcomponent desc;
--Instruccions PL/SQL
DECLARE
    id varchar(15);
BEGIN
    --Torna el nombre enter segent
    id:=tornaIdTaula('LOG','idLog');
    DBMS_OUTPUT.put_line(id);
    --Torna la combinaci de lletra i nombre enter segent de llargada 5 (per defecte)
    id:=tornaIdTaula('component','idComponent','C');
    DBMS_OUTPUT.put_line(id);
    --Torna la combinaci de lletra i nombre enter segent amb llargada 10
    id:=tornaIdTaula('component','idComponent','C',10);
    DBMS_OUTPUT.put_line(id);
END;

/*
Aquesta prova permet verificar procediments de gesti de dades d'una taula
simple d'una sola clau.
*/
--Elimina el log per tenir-ho net per la prova
DELETE FROM Log;
--Mostra la llista de components inicial
SELECT * FROM component;
DECLARE
    RSP varchar(200);
BEGIN
    --Crea dos components, prova1 i prova2
    crearComponent('prova1',RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearComponent('prova2',RSP);
    DBMS_OUTPUT.put_line(RSP);
    --modifica el primer component que hauria de tenir clau C0011
    modificarComponent('C0011','prova3',RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Esborra el segon component
    esborrarComponent('C0012',RSP);
    DBMS_OUTPUT.put_line(RSP);
END;
--Mostra el log dels processos
SELECT * FROM Log;
--Mostra els components finals
SELECT * FROM component;
--Elimina el segon component de prova
DELETE component WHERE idComponent='C0011';


/*************************/

--Esborrat de les taules implicades
delete componentUtilitzat;
delete compost;
delete LOG;

--Consultes de les taules implicades
select * from component;
select * from producte;
select * from compost;
select * from componentUtilitzat;
select * from LOG;

DECLARE
    RSP varchar(200);
BEGIN
    --Creaci de compostos
    crearCompost('P0005','C0001',600,'mL',RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearCompost('P0004','C0002',300,'mG',RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Modificaci d'un dels compostos creats
    modificarCompost('P0004','C0002',500,'mG',RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Esborrat d'un dels compostos
    esborrarCompost('P0005','C0001',RSP);
    DBMS_OUTPUT.put_line(RSP);
END;


DECLARE
    RSP varchar(200);
    producte varchar(10);
    component varchar(10);
    unitatMesura varchar(5);
BEGIN
    --Bucle de 1 a 20
    FOR i in 1..20
    LOOP
        --Omple les variables producte i component amb valors aleatoris entre els 5 primers registres
        producte:='P'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0');
        component:='C'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0');
        --Si s el primer component (aigua) la unitat de mesura s mL
        IF component LIKE 'C0001' THEN
            unitatMesura:='mL';
        --En cas contrari, s mG
        ELSE
            unitatMesura:='mG';
        END IF;
        --Crea un compost amb dades aleatries
        crearCompost(producte,component,ROUND(dbms_random.value(100,1000),0),unitatMesura,RSP);
        --Mostra el resultat de l'execuci anterior
        DBMS_OUTPUT.put_line(RSP);
    END LOOP;
END;


/**************************/

--Esborrat de les taules implicades
DELETE Produccio;
DELETE ProducteProduit;
DELETE LOG;
DELETE LiniaAturada;

--Consulta de les taules implicades
SELECT * FROM Producte;
SELECT * FROM LiniaFabricacio;
SELECT * FROM Produccio;
SELECT * FROM ProducteProduit;
SELECT * FROM LOG;
SELECT * FROM LiniaAturada;

DECLARE
    RSP varchar(200);
BEGIN
    --Creaci de produccions de producte
    crearProduccio('P0001','L0001',TO_DATE('27/03/2018 8:00:00'),TO_DATE('28/03/2018 14:00:00'),50,RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearProduccio('P0001','L0001',TO_DATE('28/03/2018 8:00:00'),TO_DATE('28/04/2018 14:00:00'),100,RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearProduccio('P0002','L0002',TO_DATE('27/03/2018 8:00:00'),TO_DATE('27/03/2018 14:00:00'),25,RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    --Modificaci d'una de les lnies anteriors
    modificarProduccio('P0001','L0001',TO_DATE('27/03/2018 8:00:00'),TO_DATE('27/03/2018 14:00:00'),20,RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    --Esborrat d'una de les lnies anteriors
    esborrarProduccio('P0002','L0002',TO_DATE('27/03/2018 8:00:00'),RSP);
    DBMS_OUTPUT.put_line(RSP);
END;

DECLARE
    RSP varchar(200);
BEGIN
    FOR i in 1..50
    LOOP
        --Creaci de produccions de producte aleatoris dels 5 primers productes i 5 primeres lnies de producci
        -- entre 10 i 48 /24 hores anteriors al dia actual i 10 i 24 /24 dies posteriors al dia actual
        -- i una quantitat entre 10 i 50
        crearProduccio('P'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'L'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),
                        SYSDATE-ROUND(dbms_random.value(10,48),0)/24,SYSDATE+ROUND(dbms_random.value(10,24),0)/24,
                        ROUND(dbms_random.value(10,50),0),RSP);
        DBMS_OUTPUT.put_line(RSP);
    END LOOP;
END;

/*******************/

--Esborrat de les taules implicades
DELETE Stock;
DELETE capacitatMagatzem;
DELETE LOG;
DELETE capacitatAnualMagatzems;
DELETE begudaProduida;
DELETE empresesDistribuides;

--Consulta de les taules implicades
SELECT * FROM empresa;
SELECT * FROM magatzem;
SELECT * FROM Stock;
SELECT * FROM empresesDistribuides;
SELECT * FROM begudaProduida;
SELECT * FROM capacitatAnualMagatzems;
SELECT * FROM capacitatMagatzem;
SELECT * FROM LOG;

--Instruccions PL/SQL
DECLARE
    RSP varchar(200);
BEGIN
    --Crea tres stocks determinats
    crearStock('S0003','M0001',TO_DATE('10-04-2019 20:10:00','DD-MM-YYYY HH24-MI-SS'),50,6,'T0001',NULL,RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearStock('S0003','M0002',TO_DATE('09-04-2019 20:10:00','DD-MM-YYYY HH24-MI-SS'),50,6,'T0001',NULL,RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearStock('S0003','M0003',TO_DATE('08-04-2019 20:10:00','DD-MM-YYYY HH24-MI-SS'),100,6,'T0001',NULL,RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearStock('S0003','M0001',TO_DATE('11-04-2019 20:10:00','DD-MM-YYYY HH24-MI-SS'),-20,-6,'T0001','EP001',RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Modifica un dels stocks anteriors
    modificarStock('S0003','M0002',TO_DATE('09-04-2019 20:10:00','DD-MM-YYYY HH24-MI-SS'),80,6,'T0001',NULL,RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Esborrra un dels stocks anteriors
    esborrarStock('S0003','M0003',TO_DATE('08-04-2019 20:10:00','DD-MM-YYYY HH24-MI-SS'),RSP);
    DBMS_OUTPUT.put_line(RSP);
END;


DECLARE
    RSP varchar(200);
BEGIN
    --Bucle de 1 fins a 100
    FOR i in 1..100
    LOOP
        --Crea un stock amb un dels 5 primers registres de Sistema de forma aleatria, un dels 5 primers registres de Magatzem aleatoris,
        -- a una data de i dies abans d'avui, amb un volum aleatori entre el 1 i 10, una quantitat entre el 1 i el 50 i un transport 
        -- aleatori entre els 5 primers
        crearStock('S'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'M'||
        LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),SYSDATE-i,dbms_random.value(1,10),dbms_random.value(1,50),
        'T'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),NULL,RSP);
        DBMS_OUTPUT.put_line(RSP);
        --s el mateix, l'nic que la data s just d'un any anterior
        crearStock('S'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'M'||
        LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),ADD_MONTHS(SYSDATE,-12)-i,dbms_random.value(1,10),dbms_random.value(1,50),
        'T'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),NULL,RSP);
        DBMS_OUTPUT.put_line(RSP);
    END LOOP;
    
    --Bucle de l'1 al 20
    FOR i in 1..20
    LOOP
        --Fa el mateix que els anteriors, noms que la quantitat s negativa i s'informa d'una empresa entre les 8 primeres aleatriament
        crearStock('S'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'M'||
        LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),SYSDATE-i,-dbms_random.value(1,10),-dbms_random.value(1,10),
        'T'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'EP'||LPAD(ROUND(dbms_random.value(1,8),0),3,'0'),RSP);
        DBMS_OUTPUT.put_line(RSP);
        --El mateix que l'anterior per amb data d'un any enrere
        crearStock('S'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'M'||
        LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),ADD_MONTHS(SYSDATE,-12)-i,-dbms_random.value(1,10),-dbms_random.value(1,10),
        'T'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'EP'||LPAD(ROUND(dbms_random.value(1,8),0),3,'0'),RSP);
        DBMS_OUTPUT.put_line(RSP);
    END LOOP;
END;

/*******************/

--Esborrat de les taules implicades
DELETE Assignacio;
DELETE empleatsUtilitzats;
DELETE LOG;
DELETE tornsAnuals;

--Consulta de les taules implicades
SELECT * FROM empleat;
SELECT * FROM torn;
SELECT * FROM Assignacio;
SELECT * FROM tornsAnuals;
SELECT * FROM empleatsUtilitzats;
SELECT * FROM LOG;

DECLARE
    RSP varchar(200);
BEGIN
    --Creaci d'Assignacions
    crearAssignacio('EM001','T0001',SYSDATE,RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearAssignacio('EM002','T0002',SYSDATE,RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Esborrat d'un dels anteriors registres
    esborrarAssignacio('EM001','T0001',SYSDATE,RSP);
    DBMS_OUTPUT.put_line(RSP);
END;

--Instruccions PL/SQL
DECLARE
    RSP varchar(200);
BEGIN
    --Bucle de 0 a 100
    FOR i in 0..100
    LOOP
        --Crea una assignaci d'un empleat aleatori entre els 15 primers amb un torn dels 4 primers 
        -- a una data del dia actual menys i (nombre del bucle)
        crearAssignacio('EM'||LPAD(ROUND(dbms_random.value(1,15),0),3,'0'),'T'||
        LPAD(ROUND(dbms_random.value(1,4),0),4,'0'),SYSDATE-i,RSP);
        DBMS_OUTPUT.put_line(RSP);
        --El mateix que en cas anterior per la data s d'un any abans
        crearAssignacio('EM'||LPAD(ROUND(dbms_random.value(1,15),0),3,'0'),'T'||
        LPAD(ROUND(dbms_random.value(1,4),0),4,'0'),ADD_MONTHS(SYSDATE,-12)-i,RSP);
        DBMS_OUTPUT.put_line(RSP);
    END LOOP;
END;


/************/

--Esborrat de les taules implicades
DELETE Demanda;
DELETE DemandaAnual;
DELETE LOG;

--Consulta de les taules implicades
SELECT * FROM Producte;
SELECT * FROM ZONADISTRIBUCIO;
SELECT * FROM Demanda;
SELECT * FROM DemandaAnual;
SELECT * FROM LOG;

DECLARE
    RSP varchar(200);
BEGIN
    --Creaci de demanda
    crearDemanda('P0001','Z0001',SYSDATE,20,RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearDemanda('P0002','Z0001',SYSDATE,20,RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Modificaci de demanda
    modificarDemanda('P0002','Z0001',SYSDATE,40,RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Esborrat de demanda
    esborrarDemanda('P0001','Z0001',SYSDATE,RSP);
    DBMS_OUTPUT.put_line(RSP);
END;


--Instruccions PL/SQL
DECLARE
    RSP varchar(200);
BEGIN
    --Bucle que va de 0 a 100
    FOR i in 0..100
    LOOP
        --Crea una demanda d'un dels 5 primers productes aleatriament, d'una de les 5 primeres zones aleatriament,
        -- de la data actual menys i (nombre del bucle) dies, amb una quantitat entre 1 i 50
        crearDemanda('P'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'Z'||
        LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),SYSDATE-i,dbms_random.value(1,50),RSP);
        DBMS_OUTPUT.put_line(RSP);
        --El mateix que abans per d'un any anterior
        crearDemanda('P'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'Z'||
        LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),add_months(SYSDATE,-12)-i,dbms_random.value(1,50),RSP);
        DBMS_OUTPUT.put_line(RSP);
    END LOOP;
END;

/************/

--Esborrat de les taules implicades
DELETE netejaAnual;
DELETE LOG;
DELETE netejament;

--Consulta de les taules implicades
SELECT * FROM neteja;
SELECT * FROM liniaFabricacio;
SELECT * FROM netejaAnual;
SELECT * FROM netejament;
SELECT * FROM LOG;

DECLARE
    RSP varchar(200);
BEGIN
    --Creaci de netejament
    crearNetejament('N0001','L0001',SYSDATE,SYSDATE+20/24,RSP);
    DBMS_OUTPUT.put_line(RSP);
    crearNetejament('N0002','L0002',SYSDATE,SYSDATE+20/24,RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Modificaci de netejament
    modificarNetejament('N0001','L0001',SYSDATE,SYSDATE+10/24,RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Esborrat de netejament
    esborrarNetejament('N0002','L0002',SYSDATE,RSP);
    DBMS_OUTPUT.put_line(RSP);
END;

--Instruccions PL/SQL
DECLARE
    RSP varchar(200);
BEGIN
    --Bucle que va de 0 a 100
    FOR i in 0..100
    LOOP
        --Crea un netejament d'un dels 5 primers grups de neteja aleatriament, d'una de les 5 primeres lnies de producci,
        -- d'una data d'inici d'avui menys i (valor de bucle) dies i de finalitzaci unes hores aleatries desprs (es passen a dies)
        crearNetejament('N'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'L'||
        LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),SYSDATE-i,SYSDATE-i+dbms_random.value(1,24)/24,RSP);
        DBMS_OUTPUT.put_line(RSP);
        --El mateix que abans per les dates sn d'un any anterior.
        crearNetejament('N'||LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),'L'||
        LPAD(ROUND(dbms_random.value(1,5),0),4,'0'),ADD_MONTHS(SYSDATE,-12)-i,ADD_MONTHS(SYSDATE,-12)-i+dbms_random.value(1,24)/24,RSP);
        DBMS_OUTPUT.put_line(RSP);
    END LOOP;
END;






