CREATE TABLE producteProduit(
    any_ integer NOT NULL,
    idProducte varchar(15) NOT NULL,
    quantitat integer NOT NULL,
    CONSTRAINT proPK PRIMARY KEY (any_,idProducte),
    CONSTRAINT proProdFK FOREIGN KEY (idProducte) REFERENCES producte (idProducte)
);

CREATE TABLE LiniaAturada(
    any_ integer NOT NULL,
    mes integer NOT NULL,
    idLinia varchar(15) NOT NULL,
    horesFuncionant float NOT NULL,
    CONSTRAINT liniaAtPK PRIMARY KEY (any_,mes,idLinia),
    CONSTRAINT liniaAtLinFK FOREIGN KEY (idLinia) REFERENCES liniaFabricacio (idLinia),
    CONSTRAINT liniaAtMesC CHECK (mes>=1 and mes<=12)
);

CREATE TABLE capacitatMagatzem(
    idMagatzem varchar(15) NOT NULL,
    espaiOcupat number(10,2) NOT NULL, 
    CONSTRAINT capMagPK PRIMARY KEY (idMagatzem),
    CONSTRAINT capMagMagFK FOREIGN KEY (idMagatzem) REFERENCES magatzem(idMagatzem),
    CONSTRAINT capMagEspP CHECK (espaiOcupat>=0)
);

CREATE TABLE empleatsUtilitzats(
    any_ integer NOT NULL,
    idEmpleat varchar(15) NOT NULL,
    nombreTorns integer NOT NULL,
    CONSTRAINT empUtPK PRIMARY KEY (any_,idEmpleat),
    CONSTRAINT empUtEmFK FOREIGN KEY (idEmpleat) REFERENCES empleat (idEmpleat)
);

CREATE TABLE demandaAnual(
    any_ integer NOT NULL,
    idProducte varchar(15) NOT NULL,
    quantitat integer NOT NULL,
    quantitatDies integer NOT NULL,
    CONSTRAINT demAnPK PRIMARY KEY(any_,idProducte),
    CONSTRAINT demAnProdFK FOREIGN KEY (idProducte) REFERENCES producte(idProducte)
);

CREATE TABLE componentUtilitzat(
    idComponent varchar(15) NOT NULL,
    nombreComposts integer NOT NULL,
    CONSTRAINT comUtPK PRIMARY KEY(idComponent),
    CONSTRAINT comUtCompFK FOREIGN KEY (idComponent) REFERENCES component(idComponent)
);

CREATE TABLE capacitatAnualMagatzems(
    any_ integer NOT NULL,
    espaiOcupat number(10,2) NOT NULL,
    espaiMaximOcupat number(10,2) NOT NULL,
    CONSTRAINT capAnMagPK PRIMARY KEY (any_),
    CONSTRAINT capAnMagEspP CHECK (espaiOcupat>=0)
);

CREATE TABLE begudaProduida(
    any_ integer NOT NULL,
    capacitatLitres decimal(10,3) NOT NULL,
    CONSTRAINT begProdPK PRIMARY KEY (any_)
);

CREATE TABLE netejaAnual(
    any_ integer NOT NULL,
    idLinia varchar(15) NOT NULL,
    hores decimal(10,2) NOT NULL,
    CONSTRAINT netAnPK PRIMARY KEY (any_,idLinia),
    CONSTRAINT netAnLinFK FOREIGN KEY (idLinia) REFERENCES liniafabricacio (idLinia)
);

CREATE TABLE tornsAnuals(
    any_ integer NOT NULL,
    tornsTotals integer NOT NULL,
    tornsComplerts integer NOT NULL,
    CONSTRAINT torAnPK PRIMARY KEY (any_)
);

CREATE TABLE empresesDistribuides(
    idEmpresa varchar(15) NOT NULL,
    idProducte varchar(15) NOT NULL,
    volum decimal(10,3) NOT NULL,
    CONSTRAINT empDistrPK PRIMARY KEY (idEmpresa),
    CONSTRAINT empDistrEmpFK FOREIGN KEY (idEmpresa) REFERENCES empresa (idEmpresa),
    CONSTRAINT empDistrProdFK FOREIGN KEY (idProducte) REFERENCES producte (idProducte)
);